import * as mc from "@minecraft/server";
import { getScore, hasEquipmentItem, random } from './all.js';
import { back_flip, knock } from './events.js';

mc.world.afterEvents.entityHitEntity.subscribe(event => {
  const
    player = event.damagingEntity,
    hurt = event.hitEntity,
    view = player.getViewDirection(),
    eventEntity = event.damagingEntity;
  if (player?.hasTag("attack") && hurt?.hasTag("attack")) hurt.runCommand(`playsound defend_hit${random(1, 3)} @a ~~~ 1`);
});

mc.world.afterEvents.entityHurt.subscribe(data => {
  const
    hurt = data.hurtEntity,
    damaging = data.damageSource.damagingEntity,
    damage = data.damage,
    cause = data.damageSource.cause,
    dano = Math.floor(1 + getScore("damage_stats1", damaging) + 0.2 * getScore("damage_stats", damaging));
  if (hurt === undefined || damaging === undefined) return;
  if (damaging?.typeId == "wesl3y:jutsu_mob" && cause == "none") {
    hurt.setRotation({x: 0, y: damaging.getRotation().y});
    knock(hurt);
  }
  if (cause == "entityAttack") {
  	if (damaging?.hasTag('Bya.trigramas')) hurt.runCommandAsync("tp @s ~~~");
  	if (!damaging?.hasTag("attack")) {
  	  const view = damaging.getViewDirection();
      damaging.applyKnockback(view.x, view.z, 0.8, 0);
      hurt.applyKnockback(view.x, view.z, 0.4, 0);
    }
    if (damaging?.typeId == "minecraft:player" && damaging.hasTag("damage_knock")) {
      damaging.removeTag("damage_knock");
      hurt.setRotation({x: 0, y: damaging.getRotation().y});
      knock(hurt);
      back_flip(damaging);
    }
    hurt.runCommand("particle wesl3y:hit_ball ~~1~");
    hurt.runCommand("particle wesl3y:hit_spike ~~1~");
    hurt.runCommand("particle wesl3y:hit_spike2 ~~1~");
    if (damaging?.typeId == "minecraft:player" && hasEquipmentItem(damaging, "Mainhand", "wesl3y:taijutsu_sennin_frogs")) hurt.runCommandAsync("particle wesl3y:taijutsu ~~1~");
  }
  if (cause == "entityAttack" || cause == "none" || cause == "suffocation") {
    hurt.runCommandAsync(`summon wesl3y:hit ~${Math.floor(random(-1.75, 1.75))}~${Math.floor(random(-0.5, 1.5))}~${Math.floor(random(-1.75, 1.75))} ~~ minecraft:entity_spawned §c-${Math.floor(damage)}`);
  }
});
             
             
             
             
             
             
             
             
             
             
             
             
             
             
             
             
             
             
                      
             
             
             
             
             
             
             
             
                 
             
             
                  
                 
             
             
                               
             
             
                  
                 
             
             
                                                
                  
                 
             
             
                                                                                                
             
                                                                                                                                                       