import * as mc from '@minecraft/server';
import { getScore, hasEquipmentItem, ItemDurability } from './all.js';
import { stats_menu, npc_ichiraku, npc_kakashi, npc_iruka0, npc_iruka, npc_shinobi, npc_tenten, npc_tsunade, npc_velha } from './menu.js';
import * as list from './list.js';
/*
let items = {
  "minecraft:trident": 9,
  "minecraft:wooden_shovel": 2,
  "minecraft:stone_shovel": 3,
  "minecraft:iron_shovel": 4,
  "minecraft:golden_shovel": 2,
  "minecraft:diamond_shovel": 5,
  "minecraft:netherite_shovel": 6,
  "minecraft:wooden_hoe": 1,
  "minecraft:stone_hoe": 2,
  "minecraft:iron_hoe": 3,
  "minecraft:golden_hoe": 1,
  "minecraft:diamond_hoe": 4,
  "minecraft:netherite_hoe": 5,
  "minecraft:wooden_axe": 3,
  "minecraft:stone_axe": 4,
  "minecraft:iron_axe": 5,
  "minecraft:golden_axe": 3,
  "minecraft:diamond_axe": 6,
  "minecraft:netherite_axe": 7,
  "minecraft:wooden_pickaxe": 2,
  "minecraft:stone_pickaxe": 3,
  "minecraft:iron_pickaxe": 4,
  "minecraft:golden_pickaxe": 2,
  "minecraft:diamond_pickaxe": 5,
  "minecraft:netherite_pickaxe": 6,
  "minecraft:wooden_sword": 4,
  "minecraft:stone_sword": 5,
  "minecraft:iron_sword": 6,
  "minecraft:golden_sword": 4,
  "minecraft:diamond_sword": 7,
  "minecraft:netherite_sword": 8,
  "wesl3y:kubikiribocho": 12,
  "wesl3y:kunai": 6,
  "wesl3y:kunai_asuma": 6,
  "wesl3y:kusanagi": 10,
  "wesl3y:scythe": 12,
  "wesl3y:byakugan_twin_lions": 9,
  "wesl3y:taijutsu_sennin_frogs": 7
}*/

export function projetil(entity, player) {
  if (entity.typeId != "wesl3y:jutsu_attack" && entity.typeId != "wesl3y:jutsu_projetil") return;
  const
    jutsuName = entity.getProperty("wesl3y:jutsu"),
    teste = jutsuName ? list.Jutsus[jutsuName] : null,
    damage = Math.floor(teste.damage + (0.25 * getScore("jutsu_stats", player))),
    name = entity.nameTag;
  entity.runCommandAsync(`damage @e[r=${teste.range},name=!"${name}",family=!attack,type=!item,type=!xp_orb] ${damage} projectile entity @e[name="${name}",type=!wesl3y:jutsu_attack,type=!wesl3y:jutsu_projetil,c=1]`);
  if (teste.knock) entity.runCommandAsync(`execute as @e[r=0.5,name=!"${name}",family=!attack,type=!item,type=!xp_orb] run scriptevent wg:knock`);
}

export function projetil2(entity, player) {
  if (entity.typeId != "wesl3y:jutsu_attack" || entity.typeId != "wesl3y:jutsu_projetil"); return;
  const
    damageP = entity.getProperty("wesl3y:damage"),
    range = entity.getProperty("wesl3y:range"),
    range2 = entity.getProperty("wesl3y:range2"),
    damage = Math.floor(damageP + (0.25 * getScore("jutsu_stats", player))),
    name = entity.nameTag == "entidade" ? getScore("level", entity) : entity.nameTag;
  if (damageP > 0) entity.runCommand(`damage @e[r=${range}.${range2},name=!"${name}",family=!attack,type=!item,type=!xp_orb] ${damage} projectile entity @e[name="${name}",type=!wesl3y:jutsu_projetil,c=1]`);
}

export function entities(entity) {
  /*entity.runCommandAsync(`execute if block ~~~ wesl3y:doton.mud run damage @s 22 suffocation entity @s`);r
  entity.runCommandAsync(`execute if block ~~~ wesl3y:doton.mud run say sla`);*/
  switch (entity.typeId) {
    case `wesl3y:gaara_classic`:
      entity.nameTag = `Gaara [§cClassic§f]\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:mission.iruka_clone`:
      entity.nameTag = `Iruka Bunshin\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:itachi_classic`:
      entity.nameTag = `Itachi [§cClassic§f]\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
    case `wesl3y:shinobi.konoha`:
      entity.nameTag = `Shinobi Konoha\nHp: §e${Math.floor(entity.getComponent("health")?.currentValue)}§f`;
    break
  }
}/*
  if (entity.hasTag("Knock")) {
    entity.runCommandAsync("particle wesl3y:impact_smash ~~1.5~");
    entity.runCommandAsync("particle wesl3y:impact_smash2 ~~1.5~");
    entity.runCommandAsync(`playanimation @s animation.ninja.knock wesl3y`);
    entity.runCommandAsync(`effect @s slowness 1 2 true`);
    entity.applyKnockback(-view.x, -view.z, 5, 0.7);
    entity.runCommandAsync('camerashake add @a[r=2] 0.4 0.2 positional');
    entity.removeTag("Knock");
  }*/

/*
export function damage(player) {
  if (!player.hasTag("damage") && !player.hasTag("damage_impact")) return;// && !player.hasTag("damage_knock")) return;
  const
    hand = player.getComponent('equippable').getEquipment('Mainhand'),
    effect = player.getEffect('strength'),
    amplifier = effect?.amplifier,
    dano = Math.floor(1 + getScore("damage_stats1", player) + 0.2 * getScore("damage_stats", player)),
    dano_efeito = effect?.amplifier ? 3 * amplifier : 0,
    dano_arma = (hand?.typeId) in items ? items[ hand.typeId ] : 0;

  player.runCommandAsync(`execute positioned ^^^1.5 run damage @e[type=!item,family=!inanimate,family=!jutsu,r=1.249] ${dano_efeito + dano_arma + dano} entity_attack entity @s`);
  if (player.hasTag("damage_knock")) player.runCommandAsync(`execute positioned ^^^1.5 run tag @e[type=!item,family=!inanimate,family=!jutsu,tag=!attack,r=1] add Knock`);
  //player.runCommandAsync(`say ${test} + ${test2} + ${dano} = ${test + test2 + dano}`);
  
  player.removeTag("damage");
  player.removeTag("damage_impact");
  player.removeTag("damage_knock");
  
  if (!hand) { return false } else ItemDurability(player, "Mainhand");
}*/

export function title(player) {
  if (player.hasTag("Inv.manda") || player.hasTag("Chk.rasengan") || player.hasTag("Rai.chidori")) return;
  const
    hpCur = Math.floor(player.getComponent("health")?.currentValue),
    hpMax = Math.floor(player.getComponent("health")?.effectiveMax),
    chkCur = Math.floor(getScore('chakra', player)),
    chkMax = Math.floor(getScore('chakraMax', player)),//100 + 20 * getScore("chakra_stats", player),
    expCur = Math.floor(getScore('exp', player)),
    expMax = Math.floor(getScore('expMax', player)),
    lvlCur = Math.floor(getScore('level', player)),
    moneyCur = Math.floor(getScore('money', player)),
    hp = Math.floor(player.getComponent("health")?.currentValue * 10 / hpMax),
    chk = Math.floor(getScore('chakra', player) * 10 / chkMax),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("senju") ? "Senju" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("uzumaki") ? "Uzumaki" : null,
    choose = getScore("choose_mode", player),
    clan_item = hasEquipmentItem(player, "Mainhand", "wesl3y:menu_hyuga") ? "Hyuga" : hasEquipmentItem(player, "Mainhand", "wesl3y:menu_uchiha") ? "Uchiha" : hasEquipmentItem(player, "Mainhand", "wesl3y:menu_modes") ? "Modes" : null,
    curse_mark = player.hasTag("curse_mark1") ? " 1" : player.hasTag("curse_mark2") ? " 2" : "",
    gates = player.getProperty('wesl3y:mode_chest') == 3 ? " 1" : player.getProperty('wesl3y:mode_chest') == 4 ? " 2" : player.getProperty('wesl3y:mode_chest') == 5 ? " 3" : player.getProperty('wesl3y:mode_chest') == 6 ? " 4" : player.getProperty('wesl3y:mode_chest') == 7 ? " 5" : player.getProperty('wesl3y:mode_chest') == 8 ? " 6" : player.getProperty('wesl3y:mode_chest') == 9 ? " 7" : player.getProperty('wesl3y:mode_chest') == 10 ? " 8" : "",
    sennin = player.hasTag("sennin_frogs") ? " Frogs" : player.hasTag("sennin_snakes") ? " Snakes" : "",
    kurama = player.hasTag("kurama1") ? " 1" : player.hasTag("kurama2") ? " 2" : player.hasTag("kurama3") ? " 3" : "";
  let bar = " ";
  switch (clan_item) {
    case `Hyuga`:
      bar = `§b>§7Byakugan§b<`;
    break
    case `Uchiha`:
      bar = `${choose == 0 ? "§b>§cSharingan§b<\n§7Mangekyou" : "§7Sharingan\n§b>§cMangekyou§b<§f"}`;
    break
    case `Modes`:
      //bar = `${choose == 0 ? "§b>§aCurse Mark" + curse_mark + "§b<\n§7Eight Gates§f" : choose == 1 ? "§b>§aEight Gates" + gates + "§b<\n§7Sennin§f" : choose == 2 ? "§b>§aSennin" + sennin + "§b<\n§7Kurama§f" : "§b>§aKurama" + kurama + "§b<\n§7Curse Mark§f"}`;
      bar = `${choose == 0 ? "§b>§aCurse Mark" + curse_mark + "§b<\n§7Eight Gates§f" : choose == 1 ? "§b>§aEight Gates" + gates + "§b<\n§7Sennin§f" : choose == 2 ? "§b>§aSennin" + sennin + "§b<\n§7Kurama§f" : "§b>§aKurama" + kurama + "§b<\n§7Curse Mark§f"}`;
    break
  }
  player.onScreenDisplay.setActionBar(`${bar}`);
  player.onScreenDisplay.setTitle(`          §l${hpCur}/${hpMax}§r\n          §l${chkCur}§r\n        §l§eExp: §f${expCur}/${expMax}§r\n§l§eLevel: §f${lvlCur}§r\n§l§eMoney: §f${moneyCur}\n§l§eClan: §f${clan}\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n[health${hp}]\n[chakra${chk}]\n[clan_${clan}]`);
}


export function menu(player) {
  const tags = player.hasTag("stats_menu") ? "stats_menu" : player.hasTag("npc_ichiraku") ? "ichiraku" : player.hasTag("npc_iruka") ? "iruka" : player.hasTag("npc_kakashi") ? "kakashi" : player.hasTag("npc_shinobi") ? "shinobi" : player.hasTag("npc_tsunade") ? "tsunade" : player.hasTag("npc_tenten") ? "tenten" : player.hasTag("npc_velha") ? "velha" : null;
  switch (tags) {
    case `stats_menu`:
      stats_menu(player);
      player.removeTag("stats_menu");
    break;
    case `ichiraku`:
      npc_ichiraku(player);
      player.removeTag("npc_ichiraku");
    break;
    case `iruka`:
      if (player.hasTag("gennin")) npc_iruka(player);
      if (!player.hasTag("gennin")) npc_iruka0(player);
      player.removeTag("npc_iruka");
    break;
    case `kakashi`:
      npc_kakashi(player);
      player.removeTag("npc_kakashi");
    break;
    case `shinobi`:
      npc_shinobi(player);
      player.removeTag("npc_shinobi");
    break;
    case `tsunade`:
      npc_tsunade(player);
      player.removeTag("npc_tsunade");
    break;
    case `tenten`:
      npc_tenten(player);
      player.removeTag("npc_tenten");
    break;
    case `velha`:
      npc_velha(player);
      player.removeTag("npc_velha");
    break;
  }
}

                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                                                                      
                                        
                                                                                                                                                                                                                                                                                                                                                                                                                                          