import * as mc from '@minecraft/server';
import { getScore, removeScore, shootPower, summonPower } from './all.js';


export async function sharingan_genjutsu(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(50 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playsound sharingan @a[r=5] ~~~ 0.5");
    player.runCommandAsync("execute positioned ^^^3.5 run effect @e[r=3] blindness 3 255 true");
    player.runCommandAsync("execute positioned ^^^3.5 run effect @e[r=3] wither 3 2 true");
    player.runCommandAsync("execute positioned ^^^3.5 run effect @e[r=3] slowness 3 1 true");
    player.runCommandAsync("execute positioned ^^^3.5 run execute at @e[r=3] run particle wesl3y:genjutsu");
    player.runCommandAsync("execute positioned ^^^3.5 run execute at @e[r=3] run particle wesl3y:genjutsu_sharingan");
    player.runCommandAsync("summon bat ~~~ ~~ itachi");
    player.runCommandAsync("summon bat ~~~ ~~ itachi");
    player.runCommandAsync("summon bat ~~~ ~~ itachi");
    player.runCommandAsync("summon bat ~~~ ~~ itachi");
    player.removeTag("in_jutsu");
  }
}





export async function earth_spears(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(80 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playsound phoenix_flower @a ~~~ 1.5");
    summonPower(player, "wesl3y:jutsu_attack", "doton.earth_spears", `${player.name}`, 0, 0, 4);
    player.removeTag("in_jutsu");
  }
}

export async function earth_golem(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(80 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playsound doton.earth_golem @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", [0, -1, 1], "doton.earth_golem", `Earth Golem [${player.name}]`, 0);
    player.removeTag("in_jutsu");
  }
}

export async function earth_wall(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(80 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playanimation @s animation.player.jutsu.earth_wall wesl3y");
    await mc.system.waitTicks(7);
    summonPower(player, "wesl3y:jutsu_attack", "doton.earth_wall", `${player.name}`, 0, 0, 2);
    player.removeTag("in_jutsu");
  }
}

export async function underworld_swamp(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(80 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playanimation @s animation.player.jutsu.earth_wall wesl3y");
    await mc.system.waitTicks(7);
    summonPower(player, "wesl3y:jutsu_attack", "doton.underworld_swamp", `${player.name}`, 0, 0, 4);
    player.removeTag("in_jutsu");
  }
}

export async function fire_ball(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(60 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra)
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playanimation @s animation.jutsu.fire_ball wesl3y");
    player.runCommandAsync("playsound fire_ball @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", null, "fire_ball", `${player.name}`);
    player.removeTag("in_jutsu");
  }
}

export async function phoenix_flower(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(80 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playsound phoenix_flower @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", null, "phoenix_flower", `${player.name}`);
    await mc.system.waitTicks(7);
    player.runCommandAsync("playsound phoenix_flower @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", null, "phoenix_flower", `${player.name}`);
    await mc.system.waitTicks(7);
    player.runCommandAsync("playsound phoenix_flower @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", null, "phoenix_flower", `${player.name}`);
    await mc.system.waitTicks(7);
    player.runCommandAsync("playsound phoenix_flower @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", null, "phoenix_flower", `${player.name}`);
    player.removeTag("in_jutsu");
  }
}

export async function explosive_clone(player){
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(80 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playsound bunsh @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", [0, -1.5, 1], "explosive_clone", `${player.nameTag}`, 0);
    await mc.system.waitTicks(3);
    player.runCommand(`scriptevent wg:clone`);
    player.removeTag("in_jutsu");
  }
}

export async function fire_dragon(player) {
  if (player.hasTag("in_jutsu") || getScore('stun', player) != 0 || getScore('jutsu_time', player) != 0) return;
  const
    anim = getScore("jutsu_stats", player) >= 120 ? "":  getScore("jutsu_stats", player) >= 90 ? "1":  getScore("jutsu_stats", player) >= 60 ? "2":  getScore("jutsu_stats", player) >= 30 ? "3": "4",
    time = getScore("jutsu_stats", player) >= 120 ? 15: getScore("jutsu_stats", player) >= 90 ? 20: getScore("jutsu_stats", player) >= 60 ? 25 : getScore("jutsu_stats", player) >= 30 ? 30 : 35,
    chakra = Math.floor(100 + getScore("jutsu_stats", player) * 3);
  if (getScore("chakra", player) < chakra) player.runCommand(`tellraw @s {"rawtext":[{"text":"§cRequires ${chakra} chakra"}]}`);
  else {
    removeScore(player, "chakra", chakra);
    player.addTag("in_jutsu");
    player.runCommand(`playanimation @s animation.jutsu.seal${anim} wesl3y`);
    await mc.system.waitTicks(time);
    player.runCommandAsync("playanimation @s animation.jutsu.fire_dragon wesl3y");
    player.runCommandAsync("playsound fire_ball @a ~~~ 1.5");
    shootPower(player, "wesl3y:jutsu_projetil", [0, 1, 1], "fire_dragon", `${player.name}`);
    player.removeTag("in_jutsu");
  }
}

                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                  
                       
                  
                  
                  
                  
                  
                  
                  
                  
                          
                  
                  
                  
                  
                  
                  
                  
                                                                                                                                                                                       
                  
                  
                                                                                                                                                                                                                                                                                                        