import * as mc from '@minecraft/server';
import * as ui from '@minecraft/server-ui';
import { addScore, getScore, random, removeScore, setScore } from './all.js';
import * as q from "./list.js";
import { msg_jutsu } from './stats.js';

const Missions = {
  0: "%menu.missions.no_mission\n\n\n%menu.missions.no_mission2",
  1: "%menu.missions.iruka1\n\n\n%menu.missions.iruka1_2\n§9%menu.missions.iruka1_3",
  2: "%menu.missions.iruka2\n\n\n%menu.missions.iruka2_2\n§9%menu.missions.iruka2_3",
  3: "%menu.missions.byakugan\n\n\n%menu.missions.byakugan2\n§9%menu.missions.byakugan2_2§0\n\n%menu.missions.byakugan3\n§9%menu.missions.byakugan3_2",
  4: "%menu.missions.new_clan\n\n\n%menu.missions.new_clan2\n§9%menu.missions.new_clan2_2§0\n\n%menu.missions.new_clan3\n§9%menu.missions.new_clan3_2§0\n\n%menu.missions.new_clan4\n§9%menu.missions.new_clan4_2§0\n\n%menu.missions.new_clan5\n§9%menu.missions.new_clan5_2§0\n\n%menu.missions.new_clan6\n§9%menu.missions.new_clan6_2§0\n\n%menu.missions.new_clan7\n§9%menu.missions.new_clan7_2§0\n\n%menu.missions.new_clan8\n§9%menu.missions.new_clan8_2§0",
  5: "",
  6: "%menu.missions.kakashi1\n\n\n%menu.missions.kakashi1_2\n§9%menu.missions.kakashi1_3§0",
  7: "%menu.missions.kakashi2\n\n\n%menu.missions.kakashi2_2\n§9%menu.missions.kakashi2_3§0",
  8: "%menu.missions.kakashi3\n\n\n%menu.missions.kakashi3_2\n§9%menu.missions.kakashi3_3§0",
  9: "",
  10: "",
  30: "%menu.missions.sharingan\n\n\n%menu.missions.sharingan2\n§9%menu.missions.sharingan2_2§0\n\n%menu.missions.sharingan3\n§9%menu.missions.sharingan3_2",
  31: "%menu.missions.mangekyou\n\n\n%menu.missions.mangekyou2\n§9%menu.missions.mangekyou2_2§0\n\n%menu.missions.mangekyou3\n§9%menu.missions.mangekyou3_2",
  32: "%menu.missions.byakugan\n\n\n%menu.missions.byakugan2\n§9%menu.missions.byakugan2_2§0\n\n%menu.missions.byakugan3\n§9%menu.missions.byakugan3_2"
}


export async function stats_wait(player) {
  await mc.system.waitTicks(1);
  stats_menu(player);
}

export async function custom_wait(player, menu) {
  await mc.system.waitTicks(1);
  menu(player);
}

export async function clan_wait(player, menu) {
  const
    random1 = random(1, 90),//1, 100
    randomclan = random1 >= 1 && random1 <= 30 ? "hyuga" : random1 >= 31 && random1 <= 50 ? "uchiha" : "uzumaki";
    //randomclan = random1 >= 1 && random1 <= 30 ? "hyuga" : random1 >= 31 && random1 <= 50 ? "uchiha" : random1 >= 51 && random1 <= 90 ? "uzumaki" : "otsutsuki";
  player.runCommandAsync(`camera @s fade time 0.25 0.25 0.25 color 0 0 0`);
  player.runCommandAsync(`function clan/${randomclan}`);
  await mc.system.waitTicks(10);
  menu(player);
}

export function camera(player) {
  const tick = mc.system.runInterval(() => {
    for (const player of mc.world.getPlayers()) {
      player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
    }
  }, 2);
}


export function custom_menu(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomFire");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) return custom_menu(player);
    if (r.selection === 0) {
      custom_wait(player, custom_menu);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_wait(player, custom_menu);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_wait(player, custom_menu);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_wait(player, custom_menu);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu(player);
    }
    if (r.selection === 5) {
      custom_menu(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait(player, custom_menu);
      } else custom_wait(player);
    }
    if (r.selection === 7) {
      custom_menu(player);
    }
    if (r.selection === 8) {
      custom_menu3(player);
    }
    if (r.selection === 9) {
      if (getScore("spin", player) <= 2) {
        player.addTag("custom");
        player.runCommandAsync(`give @s wesl3y:katon_fire_ball 1 0 {"minecraft:keep_on_death":{},"minecraft:item_lock":{"mode":"lock_in_inventory"}}`);
        player.runCommandAsync("camera @s clear");
      } else return custom_menu(player);
    }
  }
);}

export function custom_menu2(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomWater");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) player.runCommand("camera @s clear");
    if (r.selection === 0) {
      custom_wait(player, custom_menu2);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_wait(player, custom_menu2);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_wait(player, custom_menu2);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_wait(player, custom_menu2);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu2(player);
    }
    if (r.selection === 5) {
      custom_menu2(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        custom_wait(player, custom_menu2);
      } else custom_wait2(player);
    }
    if (r.selection === 7) {
      custom_menu(player);
    }
    if (r.selection === 8) {
      custom_menu3(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync("give @s wesl3y:suiton_water_dragon");
      player.runCommandAsync("camera @s clear");
    }
  }
);}

export function custom_menu3(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomEarth");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) return custom_menu3(player);
    if (r.selection === 0) {
      custom_wait(player, custom_menu3);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_wait(player, custom_menu3);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_wait(player, custom_menu3);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_wait(player, custom_menu3);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu3(player);
    }
    if (r.selection === 5) {
      custom_menu3(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait(player, custom_menu3);
      } else custom_wait(player, custom_menu3);
    }
    if (r.selection === 7) {
      custom_menu(player);
    }
    if (r.selection === 8) {
      custom_menu3(player);
    }
    if (r.selection === 9) {
      if (getScore("spin", player) <= 2) {
        player.addTag("custom");
        player.runCommandAsync(`give @s wesl3y:doton_earth_spears 1 0 {"minecraft:keep_on_death":{},"minecraft:item_lock":{"mode":"lock_in_inventory"}}`);
        player.runCommandAsync(`camera @s clear`);
      } else return custom_menu3(player);
    }
  }
);}

export function custom_menu4(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomLightning");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) player.runCommand("camera @s clear");
    if (r.selection === 0) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_wait(player, custom_menu4);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu4(player);
    }
    if (r.selection === 5) {
      custom_menu4(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait4(player);
      } else custom_wait(player, custom_menu4);
    }
    if (r.selection === 7) {
      custom_menu3(player);
    }
    if (r.selection === 8) {
      custom_menu5(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync("give @s wesl3y:raiton_gian");
    }
  }
);}

export function custom_menu5(player) {
  const
    form = new ui.ActionFormData(),
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("uzumaki") ? "Uzumaki" : "";
  player.runCommandAsync("tp @s ^^^ ~ 0");
  player.runCommandAsync("camera @s set minecraft:free ease 0.3 linear pos ^^2^2.5 rot ~15~180");
  form.title("CustomFuuton");
  form.body(`Spin: ${getScore("spin", player)}\n${clan}`);
  form.button("");//skin
  form.button("");//skin
  form.button("");//hair
  form.button("");//hair
  form.button("");//scar
  form.button("");//scar
  form.button("");//clan
  form.button("");//jutsu
  form.button("");//jutsu
  form.button("Finish");
  form.show(player).then((r) => {
    if (r.canceled) player.runCommand("camera @s clear");
    if (r.selection === 0) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:backskin");
    }
    if (r.selection === 1) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:nextskin");
    }
    if (r.selection === 2) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:backhair");
    }
    if (r.selection === 3) {
      custom_wait(player, custom_menu5);
      player.runCommandAsync("event entity @s wesl3y:nexthair");
    }
    if (r.selection === 4) {
      custom_menu5(player);
    }
    if (r.selection === 5) {
      custom_menu5(player);
    }
    if (r.selection === 6) {
      if (getScore("spin", player) > 0) {
        player.runCommandAsync("scoreboard players remove @s spin 1");
        clan_wait5(player);
      } else custom_wait(player, custom_menu5);
    }
    if (r.selection === 7) {
      custom_menu4(player);
    }
    if (r.selection === 8) {
      custom_menu5(player);
    }
    if (r.selection === 9) {
      player.addTag("custom");
      player.runCommandAsync("give @s wesl3y:raiton_gian");
    }
  }
);}

export async function stats_menu(player) {
  const form = new ui.ActionFormData();
  const
    mentor = player.hasTag("gai_mentor") ? "§aGai" : player.hasTag("kakashi_mentor") ? "§aKakashi" : "§c%palavra.nenhum",
    clan = player.hasTag("hyuga") ? "Hyuga" : player.hasTag("otsutsuki") ? "Otsutsuki" : player.hasTag("senju") ? "Senju" : player.hasTag("uchiha") ? "Uchiha" : player.hasTag("uzumaki") ? "Uzumaki" : null,
    chkScore = getScore("chakra_stats", player),
    chkMax = Math.floor(100 + 25 * getScore("chakra_stats", player)),
    chk0 = getScore("chakra_stats", player) < 10 ? "00" : getScore("chakra_stats", player) < 100 ? "0": "",
    dmgScore = getScore("damage_stats", player),
    dmgMax = Math.floor(1 + 0.2 * getScore("damage_stats", player)),
    dmg0 = getScore("damage_stats", player) < 10 ? "00" : getScore("damage_stats", player) < 100 ? "0": "",
    hpScore = getScore("health_stats", player),
    hpMax = Math.floor(20 + 15 * getScore("health_stats", player)),
    hp0 = getScore("health_stats", player) < 10 ? "00" : getScore("health_stats", player) < 100 ? "0" : "",
    jtsScore = getScore("jutsu_stats", player),
    jts0 = getScore("jutsu_stats", player) < 10 ? "00" : getScore("jutsu_stats", player) < 100 ? "0" : "",
    wpnScore = getScore("weapons_stats", player),
    wpn0 = getScore("weapons_stats", player) < 10 ? "00" : getScore("weapons_stats", player) < 100 ? "0" : "",
    tpScore = getScore(`tp`, player);
  form.title("Stats");
  form.body(`Tp: §9${tpScore}§0\nPlayer: §9${clan} ${player.name}§0\nMentor: ${mentor}§0\n\n   Chakra: §9${chk0}${chkScore}/200§0                      Max: §9${chkMax}§0\n\n   Damage: §9${dmg0}${dmgScore}/200§0                     Max: §9${dmgMax}§0\n\n   Health: §9${hp0}${hpScore}/200§0                      Max: §9${hpMax}§0\n\n   Jutsu: §9${jts0}${jtsScore}/200§0\n\n   Weapon: §cNext Version§0`);
  form.button("§e+");
  form.button("§e+");
  form.button("§e+");
  form.button("§e+");
  form.button("§e+");
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.show(player).then((r) => {
    player.removeTag("stats_menu");
    if (r.selection === 0) {
      if (getScore("chakra_stats", player) < 200) {
        if (getScore("tp", player) > 0) {
          addScore(player, "chakra_stats", 1)
          removeScore(player, "tp", 1)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§c%up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 1) {
      if (getScore("damage_stats", player) < 200) {
        if (getScore("tp", player) > 0) {
          addScore(player, "damage_stats", 1)
          removeScore(player, "tp", 1)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§c%up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 2) {
      if (getScore("health_stats", player) < 200) {
        if (getScore("tp", player) > 0) {
          addScore(player, "health_stats", 1)
          removeScore(player, "tp", 1)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§c%up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 3) {
      if (getScore("jutsu_stats", player) < 200) {
        if (getScore("tp", player) > 0) {
          addScore(player, "jutsu_stats", 1)
          removeScore(player, "tp", 1)
          player.runCommandAsync("playsound random.levelup @s ~~~ 5 1 5");
          msg_jutsu(player);
          stats_wait(player);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§c%up.no_tp"},{"text":"§f"}]}`);
      } else stats_wait(player);
    }
    if (r.selection === 4) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"text": "§cNext Version\nPróxima Versão"}]}`);
    }
    if (r.selection === 5) {
      stats_wait(player);
    }
    if (r.selection === 6) {
      stats_missions(player);
    }
  }
);}

export function stats_missions(player) {
  const
    form = new ui.ActionFormData(),
    tagMsn = player.hasTag("in_mission") ? Missions[getScore("missions", player)] : "%menu.missions.no_mission\n\n\n%menu.missions.no_mission2";
  form.title(`Mission`);
  form.body(`${tagMsn}`);
  form.button("§0");
  form.button("§0");
  form.button("§0");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      stats_menu(player);
    }
    if (r.selection === 1) {
      stats_missions(player);
    }
  }
);}





export function npc_ichiraku(player) {
  const form = new ui.ActionFormData();
  form.title("NpcShop");
  form.body("§c[Ichiraku] - §f%npc.ichiraku\n\n§c[Ichiraku] - §f%npc.oque_deseja");
  form.button("50R$ = 1x Rámen");
  form.button("200R$ = 1x Chakra Pill");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("money", player) >= 50) {
        player.runCommandAsync("give @s wesl3y:ramen");
        removeScore(player, "money", 50);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 1) {
      if (getScore("money", player) >= 200) {
        player.runCommandAsync("give @s wesl3y:chakra_pill");
        removeScore(player, "money", 200);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
  }
);}

export function npc_iruka0(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Iruka] - §f%npc.iruka0");
  form.button("Yes");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("level", player) >= 5) {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "unlock.gennin"}]}`);
        player.addTag("gennin");
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "5"}]}`);
    }
  }
);}

export function npc_iruka(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Iruka] - §f%npc.oque_deseja");
  form.button("Missions");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      npc_iruka_miss(player);
    }
  }
);}

export function npc_iruka_miss(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Iruka] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.iruka1");
  form.button("Trash");
  form.button("Clone");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 1 && getScore("level", player) <= 15) {
          setScore(player, "missions", 1);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "1..15§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 1) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 5 && getScore("level", player) <= 15) {
          setScore(player, "missions", 2);
          player.addTag("start_mission");
          player.runCommandAsync(`summon wesl3y:mission.iruka_clone ~~~1 ~~ minecraft:entity_spawned`);
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "5..15§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
  }
);}

export function npc_kakashi(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Kakashi] - §f%npc.oque_deseja");
  form.button("Mentor");
  form.button("Sharingan");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("gai_mentor") && !player.hasTag("kakashi_mentor")) {
        npc_kakashi_no_mentor(player);
      } else if (player.hasTag("kakashi_mentor")) npc_kakashi_mentor(player); else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"you.already_mentor"}]}`)
    }
    if (r.selection === 1) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"§cNo completed\"}]}");
      //npc_kakashi_sharingan(player);
    }
  }
);}

export function npc_kakashi_no_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Kakashi] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.kakashi1\n\n§c[Kakashi] - §f%npc.kakashi1_2");
  form.button("Ok");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.addTag("kakashi_mentor");
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"choose.mentor.kakashi\"}]}");
    }
    if (r.selection === 1) {
      npc_kakashi(player);
    }
  }
);}

export function npc_kakashi_mentor(player) {
  const form = new ui.ActionFormData();
  form.title("Npc3");
  form.body("§c[Kakashi] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.kakashi1_3\n\n§c[Kakashi] - §f%npc.kakashi1_4");
  form.button("Rank C");
  form.button("Rank B");
  form.button("Rank A");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 10 && getScore("level", player) <= 35) {
          setScore(player, "missions", 6);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "10..35§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 1) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"§cNo completed\"}]}");
      /*if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 30 && getScore("level", player) <= 65) {
          setScore(player, "missions", 7);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "30..65§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);*/
    }
    if (r.selection === 2) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"§cNo completed\"}]}");
      /*if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 60) {
          setScore(player, "missions", 8);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "60§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);*/
    }
  }
);}

export function npc_kakashi_sharingan(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Kakashi] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.kakashi2\n\n§c[Kakashi] - §f%npc.kakashi2_2");
  form.button("Ok");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"Sim\"}]}");
    }
    if (r.selection === 1) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"Não\"}]}");
    }
  }
);}

export function npc_shinobi(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Shinobi] - §f%npc.shinobi\n\n§c[Shinobi] - §f%npc.shinobi2\n\n§c[Shinobi] - §f%npc.shinobi3");
  form.button("Trash");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync("scoreboard players add @s[hasitem={item=wesl3y:trash_item,quantity=1..}] money 30");
      player.runCommandAsync("scoreboard players add @s[hasitem={item=wesl3y:trash_item,quantity=1..}] exp 5");
      player.runCommandAsync(`tellraw @s[hasitem={item=wesl3y:trash_item,quantity=1..}] {"rawtext":[{"text":"Thanks!"}]}`);
      player.runCommandAsync("clear @s[hasitem={item=wesl3y:trash_item,quantity=1..}] wesl3y:trash_item 0 1");
    }
    if (r.selection === 1) {}
  }
);}

export function npc_tenten(player) {
  const form = new ui.ActionFormData();
  form.title("NpcShop6");
  form.body("§c[Tenten] - §f%npc.tenten\n\n§c[Tenten] - §f%npc.oque_deseja");
  form.button("400R$ = 1x Kunai");
  form.button("500R$ = 1x Kunai Asuma");
  form.button("2500R$ = 1x Kusanagi");
  form.button("5000R$ = 1x Kubikiribocho");
  form.button("1500R$ = 1x Gunbai");
  form.button("5000R$ = 1x Scythe");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (getScore("money", player) >= 400) {
        player.runCommandAsync("give @s wesl3y:kunai");
        removeScore(player, "money", 400);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 1) {
      if (getScore("money", player) >= 500) {
        player.runCommandAsync("give @s wesl3y:kunai_asuma");
        removeScore(player, "money", 500);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 2) {
      if (getScore("money", player) >= 2500) {
        player.runCommandAsync("give @s wesl3y:kusanagi");
        removeScore(player, "money", 2500);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 3) {
      if (getScore("money", player) >= 5000) {
        player.runCommandAsync("give @s wesl3y:kubikiribocho");
        removeScore(player, "money", 5000);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 4) {
      if (getScore("money", player) >= 1500) {
        player.runCommandAsync("give @s wesl3y:gunbai");
        removeScore(player, "money", 1500);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
    if (r.selection === 5) {
      if (getScore("money", player) >= 5000) {
        player.runCommandAsync("give @s wesl3y:scythe");
        removeScore(player, "money", 5000);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "shop.no_money"}]}`);
    }
  }
);}

export function npc_tsunade(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Tsunade] - §f%npc.oque_deseja");
  form.button("Mission");
  form.button("Jutsu\nCure");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"Mission\"}]}");
      npc_tsunade1(player);
    }
    if (r.selection === 1) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"Jutsu\"}]}");
      npc_tsunade2(player);
    }
  }
);}

export function npc_tsunade1(player) {
  const form = new ui.ActionFormData();
  form.title("Npc3");
  form.body("§c[Tsunade] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.tsunade1\n\n§c[Tsunade] - §f%npc.tsunade1_2");
  form.button("Rank C");
  form.button("Rank B");
  form.button("Rank A");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 10 && getScore("level", player) <= 35) {
          setScore(player, "missions", 6);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "10..35"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
    if (r.selection === 1) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"Chunnin\"}]}");
    }
    if (r.selection === 2) {
      if (!player.hasTag("in_mission")) {
        if (getScore("level", player) >= 70) {
          setScore(player, "missions", 11);
          player.addTag("start_mission");
        } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.requires_level"},{"text": "70§f"}]}`);
      } else player.runCommandAsync(`tellraw @s {"rawtext":[{"translate": "mission.in_mission"}]}`);
    }
  }
);}

export function npc_tsunade2(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Tsunade] - §f%npc.oque_deseja\n\n§a[Você] - §f%npc.tsunade2\n\n§c[Tsunade] - §f%npc.tsunade2_2");
  form.button("Yes");
  form.button("No");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"mission.abra_menu\"}]}");
    }
    if (r.selection === 1) {
      player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"Não\"}]}");
    }
  }
);}

export function npc_velha(player) {
  const form = new ui.ActionFormData();
  form.title("Npc2");
  form.body("§c[Random] - §f%npc.velha");
  form.button("Cake");
  form.button("Back");
  form.show(player).then((r) => {
    if (r.selection === 0) {
      player.runCommandAsync("scoreboard players add @s[hasitem={item=cake,quantity=1..}] exp 15");
      player.runCommandAsync(`tellraw @s[hasitem={item=cake,quantity=1..}] {"rawtext":[{"text":"Thanks!"}]}`);
    }
    if (r.selection === 1) {}
  }
);}
                              
          
          
          
          
          
          
          
          
          
                    
                         
          
          
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                                                              
                              
                              
                              
                              
                              
                                                                                                                            
                              
                                                                                                        
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                              
                                                              
                              
                              
                              
                              
                              
                                                                                                                            
                              
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          