import * as mc from "@minecraft/server";
import * as q from "./list.js";
import { addScore, getScore, random, setScore } from "./all.js";

mc.world.afterEvents.playerSpawn.subscribe((data) => {
  const
    { player } = data,
    mission = q.Missions.list[getScore("missions", player)];
  if (player.hasTag("in_mission")) {
    inMission(player, mission);
  }
});
/*
mc.world.afterEvents.playerSpawn.subscribe((eventData) => {
  if (eventData.initialSpawn) {
    if (eventData.player.hasTag('in_mission')) {
      inMission(eventData.player, q.Mission.list[getScore("missions", eventData.player)]);
      //inMission(player, mission)
    }
  }
});*/

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers({ tags: ["start_mission"] })) {
    const mission = q.Missions.list[getScore("missions", player)];
    player.removeTag("start_mission");
    if (!player.hasTag("in_mission")) {
      player.runCommand(`tellraw @s{"rawtext":[{"translate":"menu.missions.open"}]}`);
      player.addTag("in_mission");
    }
    inMission(player, mission);
  }
}, 20);

function inMission(player, mission) {
  if (player.hasTag("finish_mission")) finishMission(player, mission);
  if (mission.summon) {
    let objectiveInimigo = [...mission.enemies];
    mc.world.afterEvents.entityHurt.subscribe(data => {
      try {
        if (data.damageSource.damagingEntity === player) {
          for (let index = 0; index < objectiveInimigo.length; index++) {
            if (objectiveInimigo[index] === data.hurtEntity.typeId) {
              if (data.hurtEntity.getComponent("minecraft:health")?.currentValue <= 0) {
                objectiveInimigo.splice(index, 1);
                if (player.hasTag("in_mission") && !objectiveInimigo.length) {
                  index = 0;
                  finishMission(player, mission);
                }
              }
            }
          }
        }
      }
      catch (error) { }
    });
  }
  if (mission.collect) {
    const time = mc.system.runInterval(() => {
      try {
        const itemAmount = getItemAmount(player, mission.item1);
        if (player.hasTag("in_mission") && itemAmount >= mission.item1Q) {
          finishMission(player, mission);
          mc.system.clearRun(time);
        }
      }
      catch (error) { }
    }, 20);
  }
}

function finishMission(player, mission) {
  player.removeTag("finish_mission");
  player.removeTag("in_mission");
  player.runCommandAsync(`tellraw @s {"rawtext":[{"text": "§e<"},{"translate": "mission.complete"},{"text": ">\n§f"},{"translate": "mission.earned"},{"text": " §a${mission.money} R$\n§f"},{"translate": "mission.earned"},{"text": " §e${random(mission.xpmin, mission.xpmax)} Exp.§f"}]}`);
  if (mission.collect) {
    player.runCommandAsync(`clear @s ${mission.item1} 0 ${mission.item1Q}`);
  }
  setScore(player, "missions", 0);
  addScore(player, "money", mission.money);
  addScore(player, "exp", random(mission.xpmin, mission.xpmax));
}

function getItemAmount(player, itemType) {
  let amount = 0
  const inv = player.getComponent("inventory").container
  for(let i = 0; i < inv.size; i++) {
    const item = inv.getItem(i)
    if(item?.typeId === itemType) amount += item.amount
  }
  return amount
}

                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                    
                                                       
                                    
                                    
                                    
                                    
                                    
                                    
                                                      
                                                
                                                
                                                                                   
                                                      
                                                
                                                
                                                       